Lattice Grid Buy a licence

demo D105

Real-Time Collaboration: Live Cursors and Presence in React

Two windows, two cursors, live selections and edits

grid.presence

This shows two windows on the same grid with each other's cursors, active cell, selections and edits rendered live. It turns a shared dataset into a shared workspace, so people can see where their colleagues are working rather than guessing from a changed value.

Building…
Loading a live grid…

This is the React version. The grid mounts through the createLatticeGrid adapter, which takes its configuration as ordinary props and hands back the live grid through a ref. The grid below is the same one every other tab runs.

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 200, pin: 'start' } },
    { field: 'region', title: 'Region' },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' } },
    { field: 'charge', title: 'Monthly charge', type: 'number', format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' } },
  ];
  const rows = [/* an array of objects, one per circuit */];

  // Your transport, which the grid does not own: subscribe hands the grid
  // each peer's cursor, ranges and edit claim, and publish sends the local
  // state back out. Wire these to your own channel (WebSocket, SSE, etc).
  const presence = {
    provider: {
      subscribe(onMessage) { return () => {}; },
      publish(state) {},
    },
    me: { id: 'you', name: 'You' },
  };

  function App() {
    return (
      // Presence positions travel as row key plus column id, never an index,
      // so a stable key is what lets two people sorting differently still
      // see each other on the same records.
      <LatticeGrid rowKey="id" selection="multiple" presence={presence} columns={columns} rows={rows} style={{ height: '540px' }} />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Showing who else is looking at the same grid

Presence is the layer that turns a shared dataset into a shared workspace: other users’ cursors, active cell, and selection rendered live inside the same JavaScript data grid rather than inferred after the fact from a changed value. A developer reaches for it once two or more people can open the same view at once, most often a shared spreadsheet-style tool, an ops dashboard during an incident, or a review pass where seeing a colleague move to a row matters more than a chat message saying so. Lattice Grid exposes this through grid.presence, which accepts a stream of remote cursor and selection positions keyed by user and renders them as overlays on the existing cell layout, without altering row or column state. Because presence overlays are painted separately from the row virtualisation pass, adding participants does not change what gets measured or redrawn as the grid scrolls: a cursor for a collaborator outside the visible window stays undrawn until scrolling brings their row into view. Each remote cursor carries a user identifier, so colour and label are assigned per person rather than per session, and a reconnecting user keeps that identity rather than appearing as new. The demo runs two windows side by side, each driving grid.presence independently, so edits and selections in one appear in the other as they happen.

How do you show other users’ cursors in a data grid?

Feed a stream of remote positions into grid.presence, keyed by user id, with each entry carrying a cell or range and a display colour or label. Lattice Grid renders these as overlays on top of the existing grid rather than as separate DOM rows, so presence updates do not affect row virtualisation, sorting, or filtering, and a user’s cursor only redraws when their position or the visible window changes.

Lattice Grid Buy a licence

demo D105

Real-Time Collaboration: Live Cursors and Presence in Angular

Two windows, two cursors, live selections and edits

grid.presence

This shows two windows on the same grid with each other's cursors, active cell, selections and edits rendered live. It turns a shared dataset into a shared workspace, so people can see where their colleagues are working rather than guessing from a changed value.

Building…
Loading a live grid…

This is the Angular version. A standalone component takes the whole configuration through one config input, surfaces grid events as outputs, and exposes the live grid on a getter for anything the inputs do not cover.

The configuration

import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { LatticeGridComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    selection: 'multiple',
    columns: [
      { field: 'circuit', title: 'Circuit', layout: { width: 200, pin: 'start' } },
      { field: 'region', title: 'Region' },
      { field: 'status', title: 'Status', filter: { type: 'set' } },
      { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' } },
      { field: 'charge', title: 'Monthly charge', type: 'number', format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' } },
    ],
    // Your transport, which the grid does not own.
    presence: {
      provider: {
        subscribe(onMessage: any) { return () => {}; },
        publish(state: any) {},
      },
      me: { id: 'you', name: 'You' },
    },
    rows: [/* an array of objects, one per circuit */],
  };
}

bootstrapApplication(AppComponent, {
  providers: [provideLattice({ createGrid })],
});

Showing who else is looking at the same grid

Presence is the layer that turns a shared dataset into a shared workspace: other users’ cursors, active cell, and selection rendered live inside the same JavaScript data grid rather than inferred after the fact from a changed value. A developer reaches for it once two or more people can open the same view at once, most often a shared spreadsheet-style tool, an ops dashboard during an incident, or a review pass where seeing a colleague move to a row matters more than a chat message saying so. Lattice Grid exposes this through grid.presence, which accepts a stream of remote cursor and selection positions keyed by user and renders them as overlays on the existing cell layout, without altering row or column state. Because presence overlays are painted separately from the row virtualisation pass, adding participants does not change what gets measured or redrawn as the grid scrolls: a cursor for a collaborator outside the visible window stays undrawn until scrolling brings their row into view. Each remote cursor carries a user identifier, so colour and label are assigned per person rather than per session, and a reconnecting user keeps that identity rather than appearing as new. The demo runs two windows side by side, each driving grid.presence independently, so edits and selections in one appear in the other as they happen.

How do you show other users’ cursors in a data grid?

Feed a stream of remote positions into grid.presence, keyed by user id, with each entry carrying a cell or range and a display colour or label. Lattice Grid renders these as overlays on top of the existing grid rather than as separate DOM rows, so presence updates do not affect row virtualisation, sorting, or filtering, and a user’s cursor only redraws when their position or the visible window changes.